package jMusic;

import jm.JMC;
import jm.music.data.*;
import jm.util.*;

public final class Drums implements JMC {

    public static void main(String[] args) {
        Score pattern = new Score("JMDemo - Kit");
        Part drums = new Part("Drums", 0, 9); // 9 = MIDI channel 10
        Phrase phrBD = new Phrase(0.0);
        Phrase phrSD = new Phrase(0.0);
        Phrase phrHH = new Phrase(0.0);
        pattern.setTempo(60);

        // General MIDI: 36 - Bass drum, 38 - Snare drum, 42 - Hi-hat (closed), 46 - Hi-hat (open)
        double ratio = 1;
        for (int i = 0; i < 16; i++) {
            if (i % 2 == 0) {
                phrBD.addNote(new Note(36, QUARTER_NOTE * ratio));
                phrSD.addNote(new Rest(QUARTER_NOTE * ratio));
                phrHH.addNote(new Note(42, EIGHTH_NOTE * ratio));
                phrHH.addNote(new Note(42, EIGHTH_NOTE * ratio));
            } else if (i % 4 == 1) {
                phrBD.addNote(new Rest(QUARTER_NOTE * ratio));
                phrSD.addNote(new Note(38, QUARTER_NOTE * ratio));
                phrHH.addNote(new Note(42, EIGHTH_NOTE * ratio));
                phrHH.addNote(new Note(42, EIGHTH_NOTE * ratio));
            } else if (i % 4 == 3) {
                phrBD.addNote(new Rest(QUARTER_NOTE * ratio));
                phrSD.addNote(new Note(38, QUARTER_NOTE * ratio));
                phrHH.addNote(new Note(42, EIGHTH_NOTE * ratio));
                phrHH.addNote(new Note(46, EIGHTH_NOTE * ratio));
            }
            ratio *= 0.95;
        }

        // add phrases to the instrument (part)
        drums.addPhrase(phrBD);
        drums.addPhrase(phrSD);
        drums.addPhrase(phrHH);

        // add the drum part to a score.
        pattern.addPart(drums);

        // write the score to a MIDIfile
        Write.midi(pattern, "Drums.mid");
    }
}
