package jMusic;

import javax.swing.JSlider;
import jm.JMC;
import jm.audio.Instrument;
import jm.audio.RTMixer;
import jm.music.data.Note;
import jm.music.rt.RTLine;

public class RealTimeController extends javax.swing.JFrame implements JMC {
    
    RTMixer mixer;
    Instrument[] instArray;
    RTLine[] lineArray;
    MyRTLine myRTLine;

    public final class MyRTLine extends RTLine {
        int center = 60;
        
        public MyRTLine(Instrument[] insts) {
            super(insts);
        }

        @Override
        public Note getNextNote() {
            Note n = new Note((int) (Math.random() * 13 + center - 6), QUAVER);
            System.out.println(n.getPitch());
            return n;
        }
        
        @Override
        public void externalAction(Object obj, int actionNumber) {
            if (actionNumber == 1) {
                JSlider slider = (JSlider)obj;
                center = slider.getValue();
            }
        }
    }

    /**
     * Creates new form RealTimeController
     */
    public RealTimeController() {
        initComponents();
        
        instArray = new Instrument[] { new SimpleFMInst(44100, 800, 34.4) };
        myRTLine = new MyRTLine(instArray);
        lineArray = new RTLine[] { myRTLine };
        mixer = new RTMixer(lineArray);
        mixer.begin();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSliderCenter = new javax.swing.JSlider();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSliderCenter.setMaximum(108);
        jSliderCenter.setMinimum(24);
        jSliderCenter.setValue(60);
        jSliderCenter.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderCenterStateChanged(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSliderCenter, javax.swing.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSliderCenter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jSliderCenterStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderCenterStateChanged
        mixer.actionLines(jSliderCenter, 1);
    }//GEN-LAST:event_jSliderCenterStateChanged

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(RealTimeController.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(RealTimeController.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(RealTimeController.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(RealTimeController.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new RealTimeController().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JSlider jSliderCenter;
    // End of variables declaration//GEN-END:variables
}
